<template>
  <div class="content">
    <vue-confirm-dialog></vue-confirm-dialog>
    <div style="margin-top: 50px;">
      <span style="font-size: 18px;"
        ><a href="#/dashboard" style="color: grey">Dashboard </a></span
      >
      <span style="font-size: 17px; padding: 0px 5px"> > </span>
      <span style="font-size: 18px">Daftar Mata Kuliah KOTA</span>
    </div>
    <h3 class="h2" style="margin-top: 30px;">
      <i class="fa fa-book" style="padding-right: 10px; font-size: 40px"></i
      ><strong>Daftar Mata Kuliah KOTA</strong>
    </h3>
    <!-- <h4>Tabel Mata Kuliah KOTA</h4> -->
    <div
      class="main"
      style="border-radius: 20px; margin-top: 30px; min-height: 400px; box-shadow: 5px 5px #c5c5c5; padding-bottom: 70px"
    >
      <div
        class="main main-raised"
        style="border-radius: 50px; float:right; top: 45px; right:20px; height: 0px"
      >
        <p
          class="md-list-item-router md-layout gradient2"
          style="border-radius: 50px; box-shadow: 5px 5px #c5c5c5"
        >
          <md-button
            @click="myFunction()"
            class="md-button1 md-simple"
            style="height: 40px; width: 220px;"
          >
            <span
              style="color: white; font-size: 14px; text-transform: capitalize"
            >
              Tambah Daftar MK KOTA
            </span>
          </md-button>
        </p>
      </div>
      <md-table
        v-model="kaprodiList.data"
        md-sort="name"
        md-sort-order="asc"
        style="padding: 50px 5px 50px 15px; border-radius: 20px;"
      >
        <md-table-toolbar style="padding-left: 10px">
          <div class="md-toolbar-section-start">
            <md-field style="padding: 5px 0px 0px 15px; max-width: 300px;">
              <label>Pilih Periode...</label>
              <md-select
                name="periode.id"
                id="periode.id"
                v-model="selectedPeriode"
                @input="searchOnTable"
                md-dense
                style="border: 0px"
              >
                <md-option
                  v-for="(periode, key) in periodeList"
                  :key="key"
                  :value="periode.id"
                  style="width:100%; left: 10px;"
                >
                  <div
                    v-if="periode.semester == '01' || periode.semester == '1'"
                  >
                    {{ periode.tahun }} (Ganjil)
                  </div>
                  <div
                    v-if="periode.semester == '02' || periode.semester == '2'"
                  >
                    {{ periode.tahun }} (Genap)
                  </div>
                </md-option>
              </md-select>
            </md-field>
          </div>
        </md-table-toolbar>

        <md-table-row slot="md-table-row" slot-scope="{ item }">
          <md-table-cell md-label="Tahun Akademik" md-sort-by="periode.tahun">
            <div v-if="item.semester == '01' || item.semester == '1'">
              {{ item.tahun }} (Ganjil)
            </div>
            <div v-if="item.semester == '02' || item.semester == '2'">
              {{ item.tahun }} (Genap)
            </div>
          </md-table-cell>
          <md-table-cell md-label="Hari dan Jam" md-sort-by="jadwal.hari">
            {{ item.hari }} ({{ item.jam }})
          </md-table-cell>
          <md-table-cell
            md-label="Ruangan"
            md-sort-by="ruangan"
            style="padding-left: 20px"
          >
            {{ item.ruangan }}
          </md-table-cell>
          <md-table-cell md-label="Kode" md-sort-by="kode_mk">
            {{ item.kode_mk }}
          </md-table-cell>
          <md-table-cell md-label="Mata Kuliah" md-sort-by="nama_mk">
            {{ item.nama_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="SKS"
            md-sort-by="sks_mk"
            style="padding-left: 15px; width: 50px"
          >
            {{ item.sks_mk }}
          </md-table-cell>
          <md-table-cell md-label="Dosen Pengampu" md-sort-by="nama">
            {{ item.nama }}
          </md-table-cell>
          <md-table-cell
            md-label="Kuota"
            md-sort-by="kuota_dibuka"
            style="padding-left: 15px; width: 50px"
          >
            {{ item.kuota_dibuka }}
          </md-table-cell>
          <md-table-cell>
            <router-link
              :to="{
                name: 'mata-kuliah-kaprodi-update',
                params: { id: item.id }
              }"
            >
              <i
                class="fa fa-edit"
                aria-hidden="true"
                style="
                color: #0b76e0;
                font-size: 18px;
              "
                ><md-tooltip md-direction="bottom"
                  >Update Mata Kuliah</md-tooltip
                ></i
              >
            </router-link>
          </md-table-cell>
          <md-table-cell>
            <md-button
              type="submit"
              class="md-simple md-danger"
              style="height: 20px;"
              @click="onDelete1(item.id)"
            >
              <i
                class="fa fa-times"
                aria-hidden="true"
                style="font-size: 20px !important"
                ><md-tooltip md-direction="bottom"
                  >Delete Mata Kuliah</md-tooltip
                ></i
              >
            </md-button>
          </md-table-cell>
        </md-table-row>
      </md-table>
    </div>

    <br />

    <h3 class="h2" style="margin-top: 50px;">
      <i class="fa fa-book" style="padding-right: 10px; font-size: 40px"></i
      ><strong>Daftar Booking Prioritas</strong>
    </h3>
    <div
      class="main"
      style="border-radius: 20px; margin-top: 30px; min-height: 400px; box-shadow: 5px 5px #c5c5c5; padding-bottom: 70px"
    >
      <div
        class="main main-raised"
        style="border-radius: 50px; float:right; top: 45px; right:20px; height: 0px"
      >
        <p
          class="md-list-item-router md-layout gradient2"
          style="border-radius: 50px; box-shadow: 5px 5px #c5c5c5"
        >
          <md-button
            @click="myFunction2()"
            class="md-button1 md-simple"
            style="height: 40px; width: 250px;"
          >
            <span
              style="color: white; font-size: 14px; text-transform: capitalize"
            >
              Tambah Booking MK KOTA
            </span>
          </md-button>
        </p>
      </div>
      <md-table
        v-model="bookedList.data"
        md-sort="name"
        md-sort-order="asc"
        style="padding: 50px 5px 50px 15px; border-radius: 20px;"
      >
        <md-table-toolbar style="padding-left: 10px">
          <div class="md-toolbar-section-start">
            <md-field style="padding: 5px 0px 0px 15px; max-width: 300px;">
              <label>Pilih Periode...</label>
              <md-select
                name="periode.id"
                id="periode.id"
                v-model="selectedPeriode2"
                @input="searchOnTable"
                md-dense
                style="border: 0px"
              >
                <md-option
                  v-for="(periode, key) in periodeList"
                  :key="key"
                  :value="periode.id"
                  style="width:100%; left: 10px;"
                >
                  <div
                    v-if="periode.semester == '01' || periode.semester == '1'"
                  >
                    {{ periode.tahun }} (Ganjil)
                  </div>
                  <div
                    v-if="periode.semester == '02' || periode.semester == '2'"
                  >
                    {{ periode.tahun }} (Genap)
                  </div>
                </md-option>
              </md-select>
            </md-field>
          </div>
        </md-table-toolbar>

        <md-table-row slot="md-table-row" slot-scope="{ item }">
          <md-table-cell md-label="Tahun Akademik" md-sort-by="periode.tahun">
            <div v-if="item.semester == '01' || item.semester == '1'">
              {{ item.tahun }} (Ganjil)
            </div>
            <div v-if="item.semester == '02' || item.semester == '2'">
              {{ item.tahun }} (Genap)
            </div>
          </md-table-cell>
          <md-table-cell md-label="Kode" md-sort-by="kode_mk">
            {{ item.kode_mk }}
          </md-table-cell>
          <md-table-cell md-label="Mata Kuliah" md-sort-by="nama_mk">
            {{ item.nama_mk }}
          </md-table-cell>
          <md-table-cell md-label="Prodi" md-sort-by="singkatan_prodi">
            {{ item.singkatan_prodi }}
          </md-table-cell>
          <md-table-cell md-label="NIM" md-sort-by="peserta">
            {{ item.peserta }}
          </md-table-cell>
          <md-table-cell>
            <router-link
              :to="{
                name: 'booking-priority-update',
                params: { id: item.id }
              }"
            >
              <i
                class="fa fa-edit"
                aria-hidden="true"
                style="
                color: #0b76e0;
                font-size: 18px;
              "
                ><md-tooltip md-direction="bottom"
                  >Update Mata Kuliah</md-tooltip
                ></i
              >
            </router-link>
          </md-table-cell>
          <md-table-cell>
            <md-button
              type="submit"
              class="md-simple md-danger"
              style="height: 20px;"
              @click="onDelete2(item.id)"
            >
              <i
                class="fa fa-times"
                aria-hidden="true"
                style="font-size: 20px !important"
                ><md-tooltip md-direction="bottom"
                  >Delete Mata Kuliah</md-tooltip
                ></i
              >
            </md-button>
            <!-- <md-dialog-confirm
              @click="onDelete(item.id)"
              :md-active.sync="first"
              md-content="Apakah anda yakin?"
              md-confirm-text="Hapus"
              md-cancel-text="Batal"
            /> -->
          </md-table-cell>
        </md-table-row>
      </md-table>
    </div>
    <md-progress-bar md-mode="indeterminate" v-if="sending" />

    <md-snackbar :md-active.sync="userSaved"
      >Proses menghapus berhasil</md-snackbar
    >
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";

export default {
  components: {},
  bodyClass: "login-page",
  //   data() {},
  data: () => ({
    total: "",
    classicModal: false,
    searched: [],
    selectedPeriode: "1",
    selectedPeriode2: "11",
    first: false
  }),
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("laporan", ["kaprodiList", "laporanList"]),
    ...mapState("bookingPriority", ["bookedList", "bookingPriorityList"]),
    ...mapState("periode", ["periodeData", "periodeList"]),
    ...mapState("prodi", ["prodiData", "prodiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.image})`
      };
    }
  },
  methods: {
    ...mapActions("laporan", ["getLaporanList", "kaprodi", "deleteLaporan"]),
    ...mapActions("bookingPriority", [
      "getBookingPriorityList",
      "booked",
      "deleteBookingPriority"
    ]),
    ...mapActions("periode", ["getPeriode", "getPeriodeList"]),
    ...mapActions("prodi", ["getProdi", "getProdiList"]),
    async onFetchData() {
      await this.getPeriodeList();
      await this.getLaporanList();
      await this.getBookingPriorityList();
      await this.kaprodi({
        periode_id: this.selectedPeriode
      });
      await this.booked({
        periode_id: this.selectedPeriode2
      });
      await this.getProdiList();
    },
    // async onNotifDelete(id) {
    //   (this.first = true), (item.id = id);
    // },
    // async onDelete(id) {
    //   // this.sending = true;
    //   try {
    //     await this.deleteBookingPriority({
    //       id: id
    //     });
    //     window.setTimeout((this.userSaved = true), 2000);
    //     this.sending = false;
    //     await this.onFetchData();
    //     // this.$router.push({ name: "report-mata-kuliah-kaprodi" });
    //   } catch (error) {
    //     throw Error(error);
    //   }
    // },
    onDelete1(id) {
      this.$confirm({
        message: `Yakin ingin menghapus data MK KOTA?`,
        button: {
          no: "Batal",
          yes: "Ya"
        },
        /**
         * Callback Function
         * @param {Boolean} confirm
         */
        callback: confirm => {
          if (confirm) {
            try {
              this.deleteLaporan({
                id: id
              });
              window.setTimeout((this.userSaved = true), 2000);
              this.sending = false;
              this.onFetchData();
              // this.$router.push({ name: "report-mata-kuliah-kaprodi" });
            } catch (error) {
              throw Error(error);
            }
            // ... do something
          }
        }
      });
    },
    onDelete2(id) {
      this.$confirm({
        message: `Yakin ingin menghapus data Booking Priority?`,
        button: {
          no: "Batal",
          yes: "Ya"
        },
        /**
         * Callback Function
         * @param {Boolean} confirm
         */
        callback: confirm => {
          if (confirm) {
            try {
              this.deleteBookingPriority({
                id: id
              });
              window.setTimeout((this.userSaved = true), 2000);
              this.sending = false;
              this.onFetchData();
              // this.$router.push({ name: "report-mata-kuliah-kaprodi" });
            } catch (error) {
              throw Error(error);
            }
            // ... do something
          }
        }
      });
    },
    myFunction: function() {
      window.open(
        "#/dashboard/mata-kuliah-kaprodi-create",
        "",
        "width=440,height=600"
      );
    },
    myFunction2: function() {
      window.open(
        "#/dashboard/booking-priority-create",
        "",
        "width=450,height=430"
      );
    },
    onResponsiveInverted() {
      if (window.innerWidth < 600) {
        this.responsive = true;
      } else {
        this.responsive = false;
      }
    },
    searchOnTable() {
      this.getLaporanList({
        periode_id: this.selectedPeriode
      });
      this.kaprodi({
        periode_id: this.selectedPeriode
      });
      this.getBookingPriorityList({
        periode_id: this.selectedPeriode
      });
      this.booked({
        periode_id: this.selectedPeriode2
      });
    },
    saveUser() {
      this.sending = true;
      window.setTimeout(() => {
        this.userSaved = true;
        this.sending = false;
        this.clearForm();
      }, 1500);
    },
    classicModalHide() {
      this.classicModal = false;
    }
  },
  async mounted() {
    await this.onFetchData();
    this.onResponsiveInverted();
    window.addEventListener("resize", this.onResponsiveInverted);
  }
  // created() {
  //   this.searched = this.bookedList.data;
  // }
};
</script>

<style lang="scss" scoped></style>

<style lang="css"></style>
